(function () { "use strict";
var Example = function() { }
Example.__name__ = true;
Example.main = function() {
	loadSound("data/start.mp3",1);
	loadSound("data/surprise.mp3",2);
	GDK.loadImage("data/stickman.png",1);
	GDK.loadImage("data/surprise.png",2);
	playSound(1);
	GDK.deltaTime();
	GDK.setMainLoop(Example.mainLoop);
}
Example.mainLoop = function() {
	var dt = GDK.deltaTime();
	var loaded = GDK.progress();
	if(loaded < 1) GDK.box(0,2,Math.floor(loaded * GDK.screenWidth()),12,255,0,0); else {
		var mx = GDK.mouseX();
		var my = GDK.mouseY();
		var mc = GDK.mouseClick();
		if(my < 14) my = 14;
		if(my > 383) my = 383;
		if(mx < 0) mx = 0;
		if(mx > 485) mx = 485;
		GDK.box(0,0,GDK.screenWidth(),GDK.screenHeight());
		var animon = false;
		if(Example.stickx < mx) {
			animon = true;
			Example.stickx++;
			if(Example.stickx > mx) Example.stickx = mx;
			Example.faceleft = 1;
		} else if(Example.stickx > mx) {
			animon = true;
			Example.stickx--;
			if(Example.stickx < mx) Example.stickx = mx;
			Example.faceleft = -1;
		}
		if(Example.sticky < my) {
			animon = true;
			Example.sticky++;
			if(Example.sticky > my) Example.sticky = my;
		} else if(Example.sticky > my) {
			animon = true;
			Example.sticky--;
			if(Example.sticky < my) Example.sticky = my;
		}
		if(animon) {
			Example.animframe += 0.25;
			if(Example.animframe > 4) Example.animframe = 0;
		}
		GDK.pasteImage(1,Example.stickx - Example.faceleft * 16,Example.sticky,Example.faceleft * 32,48,Math.floor(Example.animframe) * 32,0,32,48,127);
		var headx = Example.stickx + 10;
		var heady = Example.sticky - 2;
		GDK.line(headx,heady,headx + 6,heady - 6,0,0,0);
		Example.timeThusFar += dt;
		Example.ind = Math.floor(Example.timeThusFar / 3.0);
		if(Example.ind >= Example.lifestory.length) {
			playSound(2);
			GDK.setMainLoop(Example.otherLoop);
			return;
		}
		GDK.text(headx + 8,heady - 14,Example.lifestory[Example.ind],"left",16,90,90,90);
	}
}
Example.otherLoop = function() {
	GDK.pasteImage(2,0,0);
}
var GDK = function() { }
GDK.__name__ = true;
GDK.deltaTime = function(max) {
	if(max == null) max = 0.5;
	var now = haxe.Timer.stamp();
	var dt = now - GDK.lastUpdate;
	if(dt > max) dt = max;
	GDK.lastUpdate = now;
	return dt;
}
GDK.setMainLoopMan = function() {
	if(GDK.message == "") {
		GDK.cls();
		GDK.setMainLoopLoop();
	} else {
		GDK.response = js.Browser.window.prompt(GDK.message,GDK.response);
		if(GDK.response == null) GDK.response = "";
		GDK.message = "";
		cancelMouseClick();
	}
}
GDK.setMainLoop = function(loop,framerate) {
	if(framerate == null) framerate = 60;
	GDK.setMainLoopLoop = loop;
	if(GDK.enterFrameSetYet == true) GDK.enterFrameReplacement.stop(); else GDK.enterFrameSetYet = true;
	GDK.enterFrameReplacement = new haxe.Timer(Math.floor(1000 / framerate));
	GDK.enterFrameReplacement.run = GDK.setMainLoopMan;
}
GDK.mouseClick = function() {
	return mouseclick;
}
GDK.mouseX = function() {
	return mousex;
}
GDK.mouseY = function() {
	return mousey;
}
GDK.loadImage = function(name,number) {
	GDK.images[number] = image.loadAny(name);
}
GDK.pasteImage = function(number,positionX,positionY,width,height,sX,sY,sWidth,sHeight,a) {
	var usealpha = 255.0;
	if(width != null && height != null) {
		if(width < 0 || height < 0) {
			ctx.save();
			ctx.scale(width < 0?-1:1,height < 0?-1:1);
			positionX = width < 0?-width - positionX:positionX;
			positionY = height < 0?-height - positionY:positionY;
		}
		if(sX != null && sY != null && sWidth != null && sHeight != null) {
			sWidth = Math.abs(sWidth);
			sHeight = Math.abs(sHeight);
			if(a != null) usealpha = a;
			setAlpha(usealpha);
			ctx.drawImage(GDK.images[number],sX,sY,sWidth,sHeight,positionX,positionY,width,height);
		} else {
			if(sX != null) usealpha = sX;
			setAlpha(usealpha);
			ctx.drawImage(GDK.images[number],positionX,positionY,width,height);
		}
		if(width < 0 || height < 0) ctx.restore();
	} else {
		if(width != null) usealpha = width;
		setAlpha(usealpha);
		ctx.drawImage(GDK.images[number],positionX,positionY);
	}
}
GDK.box = function(x1,y1,x2,y2,r,g,b,a) {
	if(a == null) a = 255;
	if(b == null) b = 255;
	if(g == null) g = 255;
	if(r == null) r = 255;
	fillRGBA(r,g,b,a);
	ctx.beginPath();
	ctx.moveTo(x1,y1);
	ctx.lineTo(x2,y1);
	ctx.lineTo(x2,y2);
	ctx.lineTo(x1,y2);
	ctx.fill();
}
GDK.line = function(x1,y1,x2,y2,r,g,b,a) {
	if(a == null) a = 255;
	if(b == null) b = 255;
	if(g == null) g = 255;
	if(r == null) r = 255;
	strokeRGBA(r,g,b,a);
	ctx.beginPath();
	ctx.moveTo(x1,y1);
	ctx.lineTo(x2,y2);
	ctx.stroke();
}
GDK.oval = function(x1,y1,x2,y2,r,g,b,a) {
	if(a == null) a = 255;
	if(b == null) b = 255;
	if(g == null) g = 255;
	if(r == null) r = 255;
	var centerX = (x1 + x2) * 0.5;
	var centerY = (y1 + y2) * 0.5;
	var xRadius = Math.abs(x2 - centerX);
	var yRadius = Math.abs(y2 - centerY);
	var sides = 64;
	var pi2 = 2 * Math.PI;
	fillRGBA(r,g,b,a);
	ctx.beginPath();
	ctx.moveTo(centerX + xRadius,centerY);
	var _g = 0;
	while(_g < sides) {
		var i = _g++;
		var pointRatio = i / sides;
		var radians = pointRatio * pi2;
		var xSteps = Math.cos(radians);
		var ySteps = Math.sin(radians);
		var pointX = centerX + xSteps * xRadius;
		var pointY = centerY + ySteps * yRadius;
		ctx.lineTo(pointX,pointY);
	}
	ctx.fill();
}
GDK.polygon = function(vlist,r,g,b,a) {
	if(a == null) a = 255;
	if(b == null) b = 255;
	if(g == null) g = 255;
	if(r == null) r = 255;
	fillRGBA(r,g,b,a);
	ctx.beginPath();
	var thevert = vlist[0];
	ctx.moveTo(thevert[0],thevert[1]);
	var _g1 = 1, _g = vlist.length;
	while(_g1 < _g) {
		var i = _g1++;
		thevert = vlist[i];
		ctx.lineTo(thevert[0],thevert[1]);
	}
	ctx.fill();
}
GDK.cls = function() {
	ctx.clearRect(0,0,ctx.canvas.width,ctx.canvas.height);
}
GDK.screenWidth = function() {
	return Math.floor(ctx.canvas.width);
}
GDK.screenHeight = function() {
	return Math.floor(ctx.canvas.height);
}
GDK.progress = function() {
	return (soundProgress+image.progress)/(soundCount+image.count);
}
GDK.text = function(positionX,positionY,txt,align,size,r,g,b,a) {
	if(a == null) a = 255;
	if(b == null) b = 255;
	if(g == null) g = 255;
	if(r == null) r = 255;
	if(size == null) size = 16;
	if(align == null) align = "left";
	fillRGBA(r,g,b,a);
	superText(Std.string(txt),positionX,positionY,align,size);
}
var Std = function() { }
Std.__name__ = true;
Std.string = function(s) {
	return js.Boot.__string_rec(s,"");
}
var haxe = {}
haxe.Timer = function(time_ms) {
	var me = this;
	this.id = setInterval(function() {
		me.run();
	},time_ms);
};
haxe.Timer.__name__ = true;
haxe.Timer.stamp = function() {
	return new Date().getTime() / 1000;
}
haxe.Timer.prototype = {
	run: function() {
		console.log("run");
	}
	,stop: function() {
		if(this.id == null) return;
		clearInterval(this.id);
		this.id = null;
	}
}
var js = {}
js.Boot = function() { }
js.Boot.__name__ = true;
js.Boot.__string_rec = function(o,s) {
	if(o == null) return "null";
	if(s.length >= 5) return "<...>";
	var t = typeof(o);
	if(t == "function" && (o.__name__ || o.__ename__)) t = "object";
	switch(t) {
	case "object":
		if(o instanceof Array) {
			if(o.__enum__) {
				if(o.length == 2) return o[0];
				var str = o[0] + "(";
				s += "\t";
				var _g1 = 2, _g = o.length;
				while(_g1 < _g) {
					var i = _g1++;
					if(i != 2) str += "," + js.Boot.__string_rec(o[i],s); else str += js.Boot.__string_rec(o[i],s);
				}
				return str + ")";
			}
			var l = o.length;
			var i;
			var str = "[";
			s += "\t";
			var _g = 0;
			while(_g < l) {
				var i1 = _g++;
				str += (i1 > 0?",":"") + js.Boot.__string_rec(o[i1],s);
			}
			str += "]";
			return str;
		}
		var tostr;
		try {
			tostr = o.toString;
		} catch( e ) {
			return "???";
		}
		if(tostr != null && tostr != Object.toString) {
			var s2 = o.toString();
			if(s2 != "[object Object]") return s2;
		}
		var k = null;
		var str = "{\n";
		s += "\t";
		var hasp = o.hasOwnProperty != null;
		for( var k in o ) { ;
		if(hasp && !o.hasOwnProperty(k)) {
			continue;
		}
		if(k == "prototype" || k == "__class__" || k == "__super__" || k == "__interfaces__" || k == "__properties__") {
			continue;
		}
		if(str.length != 2) str += ", \n";
		str += s + k + " : " + js.Boot.__string_rec(o[k],s);
		}
		s = s.substring(1);
		str += "\n" + s + "}";
		return str;
	case "function":
		return "<function>";
	case "string":
		return o;
	default:
		return String(o);
	}
}
js.Browser = function() { }
js.Browser.__name__ = true;
Math.__name__ = ["Math"];
Math.NaN = Number.NaN;
Math.NEGATIVE_INFINITY = Number.NEGATIVE_INFINITY;
Math.POSITIVE_INFINITY = Number.POSITIVE_INFINITY;
Math.isFinite = function(i) {
	return isFinite(i);
};
Math.isNaN = function(i) {
	return isNaN(i);
};
String.__name__ = true;
Array.__name__ = true;
Date.__name__ = ["Date"];
Example.animframe = 0.0;
Example.stickx = 0.0;
Example.sticky = 0.0;
Example.faceleft = -1;
Example.timeThusFar = 0.0;
Example.ind = 0;
Example.lifestory = ["Let me tell you my life story.","I was born a stick figure...","Drawn with a computer mouse...","By a man of flesh and blood.","I have no name.\nI have no friends.","I am alone.","Will you be my friend?","Please be my friend...","I love you.","I love you so much, human.","I want to spend eternity with you.","You are my rock, my core, my lava...","I watch you sleep.","You are beautiful, like an angel.","Maybe if I talk to you enough...","I can get inside your brain...","And then I never have to be alone!","I will be with you forever!","You can't escape!","I will find you! I'm always there!","Watching... I am watching you.","Don't get in my way, and I will leave you alone...","But if you forget about me...","I WILL KILL YOU!","YOU CANNOT ESCAPE MY WRATH!","I WILL HUNT YOU DOWN!","Please don't hate me.","YOU MUST LOVE ME!!!!!!!!!!!!!","We're going to have some fun tonight...","If you know what I mean...","Oh yeah, baby.","Oh, yeeeeeeeeaaaaaaaaaahhhhhhhhhhhhhhh","<3","<3 <3 <3","<3 <3 <3 <3 <3 <3\n<3 <3 <3 <3 <3 <3\n<3 <3 <3 <3 <3 <3\n<3 <3 <3 <3 <3 <3\n<3 <3 <3 <3 <3 <3","LOVE ME, HUMAN!!!!!!!!!!!!!","oogie boogie jagavabawobbataba woo wa","Do you hear the telephone?\nI hear a phone ringing...","IT'S IN MY SKULL!","OH GOD, GET IT OUT!","GET IT OUT OF MY HEAD!!!!!!!!!!!!!","Do you like pancakes? I like pancakes.","But one thing I despise is waffles.","I HATE waffles.","Every time...\nI see somebody with a plate of waffles...","I feel jolly inside!","And when I feel jolly, I paint my clothes red!","HO! HO! HO!","HO! HO! HO! HO! HO! HO! HO! HO!","Do you want to play a game?","It's called,\n\"Operate a meat grinder while blindfolded.\"","Does that sound like fun? I bet it does.","Let's play.","So, find a meat grinder.","What, you don't have one?","YOU ARE DEAD!","Get over here, a little closer to the screen...","A little closer..."];
GDK.lastUpdate = 0.0;
GDK.message = "";
GDK.response = "";
GDK.enterFrameSetYet = false;
GDK.images = new Array();
js.Browser.window = typeof window != "undefined" ? window : null;
Example.main();
})();
