/*
  In this example, we are testing a feature called "delta time".
  It is the time elapsed between frames, a sort of speed factor.
  For whatever reason, its usage in this example revealed a bug in GDK.hx.
  Needless to say, the bug has been fixed in this release.

  Notice how the face bounces around the screen at an unpredictable speed.
  There are differences between the random number generators in Flash and JS.
  Therefore, the face might overall move slower in Flash than in JS or vice versa.
*/

import GDK.*;

class Example2{

	static function main(){
		loadImage("face.png",1);
		forcex=Math.random()-0.5;
		forcey=Math.random()-0.5;
		setMainLoop(mainLoop);
	}

	static var possx:Float=0.0;
	static var possy:Float=0.0;
	static var forcex:Float;
	static var forcey:Float;
	static var factor:Float=200;

	static function mainLoop(){
		if(progress()>=1){
			var dt=deltaTime();
			possx+=forcex*factor*dt;
			possy+=forcey*factor*dt;
			if(possx<0){
				possx=0;
				forcex=Math.abs(forcex);
			}
			if(possy<0){
				possy=0;
				forcey=Math.abs(forcey);
			}
			if(possx>256){
				possx=256;
				forcex=-Math.abs(forcex);
			}
			if(possy>128){
				possy=128;
				forcey=-Math.abs(forcey);
			}

			pasteImage(1,Math.floor(possx),Math.floor(possy));
		}
	}

}
