class GDK{

	static var lastUpdate:Float=0.0;

	public static function deltaTime(?max:Float=0.5):Float{
		var now:Float=haxe.Timer.stamp();
		var dt:Float=now-lastUpdate;
		if(dt>max)dt=max;
		lastUpdate=now;
		return dt;
	}

public static var message:String="";
public static var response:String="";

static var setMainLoopLoop:Dynamic;

#if (flash6||flash7||flash8)
	static var textBoxLastMouse:Bool=false;
	static var textBoxCreated:Bool=false;
	static var textBoxRef:flash.TextField;
	static var textBoxsw:Float=0.0;
	static var textBoxsh:Float=0.0;
	static var textBoxHeight:Float=0.0;
#end

	static function setMainLoopMan():Void{
		if(message==""){
			cls();
			setMainLoopLoop();
		}else{
			#if (flash6||flash7||flash8)
			if(!textBoxCreated){
				textBoxsw=screenWidth();
				textBoxsh=screenHeight();
				textBoxHeight=textBoxsh/22.4;
				box(0,0,textBoxsw,textBoxsh,0,0,0,128);
				box(0.1*textBoxsw,0.1*textBoxsh,0.9*textBoxsw,0.9*textBoxsh,0,0,127);
				text(0.15*textBoxsw,0.15*textBoxsh,message,"left",textBoxHeight,255,255,255);
				box(0,0.8*textBoxsh-textBoxHeight*3,textBoxsw,0.8*textBoxsh-textBoxHeight,255,255,255,128);
				textBoxRef=textInternal(0,0.8*textBoxsh-textBoxHeight*3,response,"left",textBoxHeight,0,0,0,255,"input");
				flash.Selection.setFocus(textBoxRef);
				flash.Selection.setSelection(0,response.length);
				box(0,0.8*textBoxsh-textBoxHeight,textBoxsw*0.5,textBoxsh,0,255,0,128);
				box(textBoxsw*0.5,0.8*textBoxsh-textBoxHeight,textBoxsw,textBoxsh,255,0,0,128);
				text(textBoxsw*0.25,textBoxsh-textBoxHeight*3.3,"A","center",textBoxHeight);
				text(textBoxsw*0.75,textBoxsh-textBoxHeight*3.3,"C","center",textBoxHeight);
				textBoxCreated=true;
				mOn=false;
			}
			var butstat=mouseClick();
			if(flash.Key.isDown(flash.Key.ENTER)){
				response=textBoxRef.text;
				textBoxCreated=false;
				message="";
			}else if(textBoxLastMouse&&!butstat&&mouseY()>=0.8*textBoxsh-textBoxHeight){
				if(mouseX()<textBoxsw*0.5){
					response=textBoxRef.text;
				}else{
					response="";
				}
				textBoxCreated=false;
				message="";
			}
			textBoxLastMouse=butstat;
			#elseif js
			response=js.Browser.window.prompt(message,response);
			if(response==null)response="";
			message="";
			untyped __js__("cancelMouseClick()");
			#end
		}
	}

#if (!flash)
	static var enterFrameReplacement:haxe.Timer;
	static var enterFrameSetYet:Bool=false;
#end

	public static function setMainLoop(loop:Dynamic,?framerate:Float=60):Void{
		setMainLoopLoop=loop;
	#if (flash6||flash7||flash8)
		flash.Lib._root.onEnterFrame=setMainLoopMan;
	#elseif flash
		flash.Lib.current.stage.frameRate=framerate;
		flash.Lib.current.stage.addEventListener(flash.events.Event.ENTER_FRAME,setMainLoopMan);
	#else
		if(enterFrameSetYet==true){
			enterFrameReplacement.stop();
		}else{
			enterFrameSetYet=true;
		}
		enterFrameReplacement=new haxe.Timer(Math.floor(1000/framerate));
		enterFrameReplacement.run=setMainLoopMan;
	#end
	}

#if (flash6||flash7||flash8)

	static function __init__():Void{
		flash.Stage.align="C";
	}

	static var mOn:Bool=false;
	static var mAdded:Bool=false;

	public static function mouseClick():Bool{
		if(mAdded==false){
			mAdded=true;
			flash.Mouse.addListener({
				onMouseDown:function(){
					mOn=true;
				},

				onMouseUp:function(){
					mOn=false;
				}
			});
		}
		return mOn;
	}

	public static function mouseX():Float{
		return flash.Lib._root._xmouse;
	}

	public static function mouseY():Float{
		return flash.Lib._root._ymouse;
	}

	static var sounds=new Array();

	public static function loadSound(name:String,number:Int):Void{
		var snd = new flash.Sound();
		snd.attachSound(name);
		sounds[number]=snd;
	}

	public static function playSound(number:Int):Void{
		var snd=sounds[number];
		snd.onSoundComplete=null;
		snd.start();
	}

	public static function loopSound(number:Int):Void{
		var snd=sounds[number];
		snd.onSoundComplete=function(){snd.start();}
		snd.start();
	}

	public static function stopSound(number:Int):Void{
		var snd=sounds[number];
		snd.onSoundComplete=null;
		snd.stop();
	}

	static var images=new Array();
	static var instances=new Array();
	static var clipnum=0;

	public static function loadImage(name:String,number:Int):Void{
		images[number]=name;
	}

	public static function pasteImage(number:Int,positionX:Float,positionY:Float,?width:Float,?height:Float,?sX:Float,?sY:Float,?sWidth:Float,?sHeight:Float,?a:Float):Void{
		var symb=flash.Lib._root.attachMovie(images[number],"clip"+clipnum,clipnum,{_x:positionX,_y:positionY});
		var clipnum1=clipnum;
		var usealpha=255.0;
		clipnum++;
		if(width!=null&&height!=null){
			var symw=symb._width;
			var symh=symb._height;
			if(sX!=null&&sY!=null&&sWidth!=null&&sHeight!=null){
				sWidth=Math.abs(sWidth);
				sHeight=Math.abs(sHeight);
				var symb2=flash.Lib._root.createEmptyMovieClip("clip"+clipnum,clipnum);
				symb2.beginFill(0xFFFFFF);
				symb2.moveTo(0,0);
				symb2.lineTo(width,0);
				symb2.lineTo(width,height);
				symb2.lineTo(0,height);
				symb2.endFill();
				symb2._x=positionX;
				symb2._y=positionY;
				var tscX=(symw/sWidth*width/symw);
				var tscY=(symh/sHeight*height/symh);
				symb._x=positionX-sX*tscX;
				symb._y=positionY-sY*tscY;
				symb._xscale=tscX*100.0;
				symb._yscale=tscY*100.0;
				symb.setMask(symb2);
				instances[clipnum]=symb2;
				clipnum++;
				if(a!=null)usealpha=a;
			}else{
				symb._xscale=(width/symw)*100.0;
				symb._yscale=(height/symh)*100.0;
				if(sX!=null)usealpha=sX;
			}
		}else if(width!=null){
			usealpha=width;
		}
		symb._alpha=usealpha*100.0/255.0;
		instances[clipnum1]=symb;
	}

	public static function box(x1:Float,y1:Float,x2:Float,y2:Float,?r:Float=255,?g:Float=255,?b:Float=255,?a:Float=255):Void{
		var symb=flash.Lib._root.createEmptyMovieClip("clip"+clipnum,clipnum);
		symb.beginFill(((Math.floor(r)<<16)|(Math.floor(g)<<8)|Math.floor(b)),a*100.0/255.0);
		symb.moveTo(x1,y1);
		symb.lineTo(x2,y1);
		symb.lineTo(x2,y2);
		symb.lineTo(x1,y2);
		symb.endFill();
		instances[clipnum]=symb;
		clipnum++;
	}

	public static function line(x1:Float,y1:Float,x2:Float,y2:Float,?r:Float=255,?g:Float=255,?b:Float=255,?a:Float=255):Void{
		var symb=flash.Lib._root.createEmptyMovieClip("clip"+clipnum,clipnum);
		symb.lineStyle(1,((Math.floor(r)<<16)|(Math.floor(g)<<8)|Math.floor(b)),a*100.0/255.0);
		symb.moveTo(x1,y1);
		symb.lineTo(x2,y2);
		symb.lineStyle();
		instances[clipnum]=symb;
		clipnum++;
	}

	public static function oval(x1:Float,y1:Float,x2:Float,y2:Float,?r:Float=255,?g:Float=255,?b:Float=255,?a:Float=255):Void{
		var centerX=(x1+x2)*0.5;
		var centerY=(y1+y2)*0.5;
		var xRadius=Math.abs(x2-centerX);
		var yRadius=Math.abs(y2-centerY);
		var sides=64;
		var pi2=2*Math.PI;
		var symb=flash.Lib._root.createEmptyMovieClip("clip"+clipnum,clipnum);
		symb.beginFill(((Math.floor(r)<<16)|(Math.floor(g)<<8)|Math.floor(b)),a*100.0/255.0);
		symb.moveTo(centerX+xRadius,centerY);
		for(i in 0 ... sides){
			var pointRatio=i/sides;
			var radians=pointRatio*pi2;
			var xSteps=Math.cos(radians);
			var ySteps=Math.sin(radians);
			var pointX=centerX+xSteps*xRadius;
			var pointY=centerY+ySteps*yRadius;
			symb.lineTo(pointX,pointY);
		}
		symb.endFill();
		instances[clipnum]=symb;
		clipnum++;
	}

	public static function polygon(vlist:Array<Array<Float>>,?r:Float=255,?g:Float=255,?b:Float=255,?a:Float=255):Void{
		var symb=flash.Lib._root.createEmptyMovieClip("clip"+clipnum,clipnum);
		symb.beginFill(((Math.floor(r)<<16)|(Math.floor(g)<<8)|Math.floor(b)),a*100.0/255.0);
		var thevert=vlist[0];
		symb.moveTo(thevert[0],thevert[1]);
		for(i in 1 ... vlist.length){
			thevert=vlist[i];
			symb.lineTo(thevert[0],thevert[1]);
		}
		symb.endFill();
		instances[clipnum]=symb;
		clipnum++;
	}

	public static function cls():Void{
		for(i in 0 ... clipnum){
			instances[i].removeMovieClip();
		}
		instances=new Array();
		clipnum=0;
		flash.Lib._root.clear();
	}

	public static function screenWidth():Int{
		return Math.floor(flash.Stage.width);
	}

	public static function screenHeight():Int{
		return Math.floor(flash.Stage.height);
	}

	public static function progress():Float{
		return flash.Lib._root.getBytesLoaded()/flash.Lib._root.getBytesTotal();
	}

	static function textInternal(positionX:Float,positionY:Float,txt:String,align:String,size:Float,r:Float,g:Float,b:Float,a:Float,typ:String):flash.TextField{
		var mc=flash.Lib._root.createEmptyMovieClip("clip"+clipnum,clipnum);
		mc.createTextField("tf",0,positionX,positionY,0,0);
		var myText:flash.TextField=Reflect.getProperty(mc,"tf");
		if(typ=="dynamic"){
			myText.selectable=false;
			myText.autoSize=align;
		}else{
			myText._width=flash.Stage.width-positionX;
			myText._height=size*2;
		}
		if(size<100){
			myText.setNewTextFormat(new flash.TextFormat("_sans",size*0.879));
		}else{
			myText.setNewTextFormat(new flash.TextFormat("_sans",100));
			myText._xscale=size*0.879;
			myText._yscale=size*0.879;
		}
		myText.type=typ;
		myText.textColor=((Math.floor(r)<<16)|(Math.floor(g)<<8)|Math.floor(b));
		myText._alpha=a*100.0/255.0;
		myText.border=false;
		myText.text=txt;
		instances[clipnum]=mc;
		clipnum++;
		return myText;
	}

	public static function text(positionX:Float,positionY:Float,txt:Dynamic,?align:String="left",?size:Float=16,?r:Float=255,?g:Float=255,?b:Float=255,?a:Float=255):Void{
		var txtlines:Array<String>=Std.string(txt).split("\r").join("\n").split("\n");
		for(i in 0 ... txtlines.length){
			textInternal(positionX,size*i+positionY,txtlines[i],align,size,r,g,b,a,"dynamic");
		}
	}

#elseif js

	public static function mouseClick():Bool{
		return untyped __js__("mouseclick");
	}

	public static function mouseX():Float{
		return untyped __js__("mousex");
	}

	public static function mouseY():Float{
		return untyped __js__("mousey");
	}

	/*@:extern inline static function doSomething(someParam:String,?optionalParam:String){return untyped __js__("doSomething")(someParam,optionalParam);}*/

	@:extern public inline static function loadSound(name:String,number:Int):Void{untyped __js__("loadSound")(name,number);}

	@:extern public inline static function playSound(number:Int):Void{untyped __js__("playSound")(number);}

	@:extern public inline static function loopSound(number:Int):Void{untyped __js__("loopSound")(number);}

	@:extern public inline static function stopSound(number:Int):Void{untyped __js__("stopSound")(number);}

	/*@:extern public inline static function soundExist(number:Int):Bool{return untyped __js__("soundExist")(number);}*/

	static var images=new Array();

	public static function loadImage(name:String,number:Int):Void{
		images[number]=untyped __js__("image.loadAny")(name);
	}

	public static function pasteImage(number:Int,positionX:Float,positionY:Float,?width:Float,?height:Float,?sX:Float,?sY:Float,?sWidth:Float,?sHeight:Float,?a:Float):Void{
		var usealpha=255.0;
		if(width!=null&&height!=null){
				if(width<0||height<0){
					untyped __js__("ctx.save")();
					untyped __js__("ctx.scale")(width<0?-1:1,height<0?-1:1);
					positionX=width<0?-width-positionX:positionX;
					positionY=height<0?-height-positionY:positionY;
				}
				if(sX!=null&&sY!=null&&sWidth!=null&&sHeight!=null){
					sWidth=Math.abs(sWidth);
					sHeight=Math.abs(sHeight);
					if(a!=null)usealpha=a;
					untyped __js__("setAlpha")(usealpha);
					untyped __js__("ctx.drawImage")(images[number],sX,sY,sWidth,sHeight,positionX,positionY,width,height);
				}else{
					if(sX!=null)usealpha=sX;
					untyped __js__("setAlpha")(usealpha);
					untyped __js__("ctx.drawImage")(images[number],positionX,positionY,width,height);
				}
				if(width<0||height<0)untyped __js__("ctx.restore")();
		}else{
			if(width!=null)usealpha=width;
			untyped __js__("setAlpha")(usealpha);
			untyped __js__("ctx.drawImage")(images[number],positionX,positionY);
		}
	}

	public static function box(x1:Float,y1:Float,x2:Float,y2:Float,?r:Float=255,?g:Float=255,?b:Float=255,?a:Float=255):Void{
		untyped __js__("fillRGBA")(r,g,b,a);
		untyped __js__("ctx.beginPath()");
		untyped __js__("ctx.moveTo")(x1,y1);
		untyped __js__("ctx.lineTo")(x2,y1);
		untyped __js__("ctx.lineTo")(x2,y2);
		untyped __js__("ctx.lineTo")(x1,y2);
		untyped __js__("ctx.fill()");
	}

	public static function line(x1:Float,y1:Float,x2:Float,y2:Float,?r:Float=255,?g:Float=255,?b:Float=255,?a:Float=255):Void{
		untyped __js__("strokeRGBA")(r,g,b,a);
		untyped __js__("ctx.beginPath()");
		untyped __js__("ctx.moveTo")(x1,y1);
		untyped __js__("ctx.lineTo")(x2,y2);
		untyped __js__("ctx.stroke()");
	}

	public static function oval(x1:Float,y1:Float,x2:Float,y2:Float,?r:Float=255,?g:Float=255,?b:Float=255,?a:Float=255):Void{
		var centerX=(x1+x2)*0.5;
		var centerY=(y1+y2)*0.5;
		var xRadius=Math.abs(x2-centerX);
		var yRadius=Math.abs(y2-centerY);
		var sides=64;
		var pi2=2*Math.PI;
		untyped __js__("fillRGBA")(r,g,b,a);
		untyped __js__("ctx.beginPath()");
		untyped __js__("ctx.moveTo")(centerX+xRadius,centerY);
		for(i in 0 ... sides){
			var pointRatio=i/sides;
			var radians=pointRatio*pi2;
			var xSteps=Math.cos(radians);
			var ySteps=Math.sin(radians);
			var pointX=centerX+xSteps*xRadius;
			var pointY=centerY+ySteps*yRadius;
			untyped __js__("ctx.lineTo")(pointX,pointY);
		}
		untyped __js__("ctx.fill()");
	}

	public static function polygon(vlist:Array<Array<Float>>,?r:Float=255,?g:Float=255,?b:Float=255,?a:Float=255):Void{
		untyped __js__("fillRGBA")(r,g,b,a);
		untyped __js__("ctx.beginPath()");
		var thevert=vlist[0];
		untyped __js__("ctx.moveTo")(thevert[0],thevert[1]);
		for(i in 1 ... vlist.length){
			thevert=vlist[i];
			untyped __js__("ctx.lineTo")(thevert[0],thevert[1]);
		}
		untyped __js__("ctx.fill()");
	}

	public static function cls():Void{
		untyped __js__("ctx.clearRect(0,0,ctx.canvas.width,ctx.canvas.height)");
	}

	public static function screenWidth():Int{
		return Math.floor(untyped __js__("ctx.canvas.width"));
	}

	public static function screenHeight():Int{
		return Math.floor(untyped __js__("ctx.canvas.height"));
	}

	public static function progress():Float{
		return untyped __js__("(soundProgress+image.progress)/(soundCount+image.count)");
	}

	public static function text(positionX:Float,positionY:Float,txt:Dynamic,?align:String="left",?size:Float=16,?r:Float=255,?g:Float=255,?b:Float=255,?a:Float=255):Void{
		untyped __js__("fillRGBA")(r,g,b,a);
		untyped __js__("superText")(Std.string(txt),positionX,positionY,align,size);
	}

#end

}